---
title: '<datalist>: The HTML Data List element'
slug: Web/HTML/Element/datalist
tags:
  - Element
  - HTML
  - HTML forms
  - HTML5
  - Reference
  - Web
---
<div>{{HTMLRef}}</div>

<p><span class="seoSummary">The <strong>HTML <code>&lt;datalist&gt;</code> element</strong> contains a set of {{HTMLElement("option")}} elements that represent the permissible or recommended options available to choose from within other controls.</span></p>

<div>{{EmbedInteractiveExample("pages/tabbed/datalist.html", "tabbed-standard")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples </a> and send us a pull request.</div>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row"><a href="/en-US/docs/Web/Guide/HTML/Content_categories">Content categories</a></th>
   <td><a href="/en-US/docs/Web/Guide/HTML/Content_categories#Flow_content">Flow content</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a>.</td>
  </tr>
  <tr>
   <th scope="row">Permitted content</th>
   <td>Either <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a> or zero or more {{HTMLElement("option")}} elements.</td>
  </tr>
  <tr>
   <th scope="row">Tag omission</th>
   <td>{{no_tag_omission}}</td>
  </tr>
  <tr>
   <th scope="row">Permitted parents</th>
   <td>Any element that accepts <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a>.</td>
  </tr>
  <tr>
   <th scope="row">Implicit ARIA role</th>
   <td><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/listbox_role">listbox</a></td>
  </tr>
  <tr>
   <th scope="row">Permitted ARIA roles</th>
   <td>No <code>role</code> permitted</td>
  </tr>
  <tr>
   <th scope="row">DOM interface</th>
   <td>{{domxref("HTMLDataListElement")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Attributes">Attributes</h2>

<p>This element has no other attributes than the <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a>, common to all elements.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_datalist">Basic datalist</h3>

<pre class="brush: html notranslate">&lt;label for="myBrowser"&gt;Choose a browser from this list:&lt;/label&gt;
&lt;input list="browsers" id="myBrowser" name="myBrowser" /&gt;
&lt;datalist id="browsers"&gt;
  &lt;option value="Chrome"&gt;
  &lt;option value="Firefox"&gt;
  &lt;option value="Internet Explorer"&gt;
  &lt;option value="Opera"&gt;
  &lt;option value="Safari"&gt;
  &lt;option value="Microsoft Edge"&gt;
&lt;/datalist&gt;
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Basic_datalist", '100%', 100)}}</p>

<h3 id="Customizing_datalist_styles">Customizing datalist styles</h3>

<p>The style of the list produced by a <code>&lt;datalist&gt;</code> element is platform-dependent, so if you want to customize the display of the options, you have to implement your own custom solution that overrides the default behavior. The below example provides a simple solution for this. Note how we haven't specified the <code>&lt;datalist&gt;</code> <code>id</code> inside the <code><a href="/en-US/docs/Web/HTML/Element/input">&lt;input&gt;</a></code> <code>list</code> attribute in this case, as that stops the browser-specific display of the data list items from kicking in. Instead, we are setting the selected <code>&lt;datalist&gt;</code> value in the <code>&lt;input&gt;</code> via JavaScript.</p>

<div class="notecard note">
<p><strong>Note</strong>: Since <code><a href="/en-US/docs/Web/CSS/::after">::after</a></code> is not permitted on <code>&lt;input&gt;</code> elements, if you want to reproduce the arrow-down icon you will have to wrap the <code>&lt;input&gt;</code> element in another element that you can hang the styling on (or some other suitable solution).</p>
</div>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;input
  list=""
  name="option"
  id="input"
  autocomplete="off"
&gt;

&lt;datalist id="datalist"&gt;
  &lt;option&gt;Carrots&lt;/option&gt;
  &lt;option&gt;Peas&lt;/option&gt;
  &lt;option&gt;Beans&lt;/option&gt;
&lt;/datalist&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">datalist {
  position: absolute;
  background-color: lightgrey;
  font-family: sans-serif;
  font-size: 0.8rem;
}

option {
  background-color: #bbb;
  padding: 4px;
  margin-bottom: 1px;
  cursor: pointer;
}
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">input.onfocus = function () {
  datalist.style.display = 'block';
}

for (let option of datalist.options) {
  option.onclick = function () {
    input.value = this.value;
    datalist.style.display = 'none';
  }
}

datalist.style.width = input.offsetWidth + 'px';
datalist.style.left = input.offsetLeft + 'px';
datalist.style.top = input.offsetTop + input.offsetHeight + 'px';</pre>

<h4 id="Result_2">Result</h4>

<p>{{EmbedLiveSample('Customizing_datalist_styles', '100%', 200)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'forms.html#the-datalist-element', '&lt;datalist&gt;')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'sec-forms.html#the-datalist-element', '&lt;datalist&gt;')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.datalist")}}</p>

<h2 id="Polyfill">Polyfill</h2>

<p>Include this polyfill to provide support for older and currently incompatible browsers:<br>
 <a href="https://github.com/mfranzke/datalist-polyfill">datalist-polyfill</a></p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{HTMLElement("input")}} element, and more specifically its {{htmlattrxref("list", "input")}} attribute;</li>
 <li>The {{HTMLElement("option")}} element.</li>
</ul>
